macro pause @0

    M8C_SetBank1               ; 4 
    mov   A, reg[0xe0]         ; 6 Get delay value
    M8C_SetBank0               ; 4

    and   A,07h                ; 4 Mask off only the clock bits	
    jz Mhz3
    cmp a,0x01
    jz  Mhz6
    cmp a,0x02    
    jz  Mhz12
    cmp a,0x03    
    jz  Mhz24
    cmp a,0x04
    jz  Khz1500
    cmp a,0x05    
    jz  Khz750
    cmp a,0x06   
    jz  Khz187    
    cmp a,0x07    
    jz  Khz93
	jmp loop1        
Mhz3:    
   	mov a,<@0
	push a
	mov a,>@0
	push a	
	mov X,SP
	mov a,[X-2]
	jmp loop1	

Mhz6:    
   	mov a,<(@0*2)
	push a
	mov a,>(@0*2)
	push a	
	mov X,SP
	mov a,[X-2]
	jmp loop1	
Mhz12:    
   	mov a,<(@0*4)
	push a
	mov a,>(@0*4)
	push a	
	mov X,SP
	mov a,[X-2]
	jmp loop1	

Mhz24:    
   	mov a,<(@0*6)
	push a
	mov a,>(@0*6)
	push a	
	mov X,SP
	mov a,[X-2]
	jmp loop1	
Khz1500:    
   	mov a,<(@0/2)
	push a
	mov a,>(@0/2)
	push a	
	mov X,SP
	mov a,[X-2]
	jmp loop1	

Khz750:    
   	mov a,<(@0/4)
	push a
	mov a,>(@0/4)
	push a	
	mov X,SP
	mov a,[X-2]
	jmp loop1	
Khz187:    
   	mov a,<(@0/16)
	push a
	mov a,>(@0/16)
	push a	
	mov X,SP
	mov a,[X-2]
	jmp loop1	

Khz93:    
   	mov a,<(@0/32)
	push a
	mov a,>(@0/32)
	push a	
	mov X,SP
	mov a,[X-2]
	jmp loop1	

loop1:
	jz dechi
	call Delay1ms
	dec [X-2]
	jmp loop1	
dechi:
	mov a,  [X-1]
	jz Kraj
	call Delay1ms
	dec [X-1]
	dec[X-2]
	jmp loop1


	
Delay1ms:	;call +push+pop+ret =43 +a*x*113+9*x
_Delay1ms:


	mov a,35		;5			;3000/84=36
Label1:

    call  Delay25u	;75		75+4+5=84
	dec a		    ;4
    jnz   Label1	;5

   ret    


     
Delay25u:						;56+11+8=75 taktova
_Delay25u:                      
;16 nop instrukcija=56 taktova
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
	nop
					;4
    ret                
;------------------------------------------------------------------------
Kraj:
	pop a
	pop a
endm
